;; The cube, 41063625 (3453), can be permuted to produce two other
;; cubes: 56623104 (3843) and 66430125 (4053). In fact, 41063625 is
;; the smallest cube which has exactly three permutations of its
;; digits which are also cube.

;; Find the smallest cube for which exactly five permutations of its
;; digits are cube.

(defun normalize (num)
  (sort (format nil "~d" num) #'char<))

;; (normalize 312)
;; (normalize 100)

(defun hash-push (ht key item)
  (if (gethash key ht)
      (setf (gethash key ht)
	    (cons item (gethash key ht)))
      (setf (gethash key ht)
	    (list item))))

(defun cube-search (&optional (max 1000))
  (let ((ht (make-hash-table :test #'equal)))
    (loop for ii from 1 to max
	  for nrm = (normalize (expt ii 3)) then (normalize (expt ii 3))
	  do
	  (hash-push ht nrm (expt ii 3))
	  (when (= (length (gethash nrm ht)) 5)
	    (format t "mult: ~a => ~a~&"
		    (length (gethash nrm ht))
		    (gethash nrm ht))
	    (return t)))))

(cube-search 10000)